package Fortuitous {
// Inserted straight from Solar Freeze, with slight modification
function SiegeGame::enterMissionArea(%game, %playerData, %player)
{
   %player.client.outOfBounds = false;
   messageClient(%player.client, 'EnterMissionArea', '\c1You are back in the mission area.');
   logEcho(%player.client.nameBase@" (pl "@%player@"/cl "@%player.client@") entered mission area");
   cancel(%player.alertThread);
}

function SiegeGame::leaveMissionArea(%game, %playerData, %player)
{
   if(%player.getState() $= "Dead")
      return;

   %player.client.outOfBounds = true;
   logEcho(%player.client.nameBase@" (pl "@%player@"/cl "@%player.client@") left mission area");
   if(%player.client.team == Game.offenseTeam)
      messageClient(%player.client, 'LeaveMissionArea', '\c1You have left the mission area.~wfx/misc/warning_beep.wav');
   else
   {
      messageClient(%player.client, 'LeaveMissionArea', '\c1You have left the mission area. Return in three seconds or die.~wfx/misc/warning_beep.wav');
      %player.alertThread = %game.schedule(1000, "SiegeAlertPlayer", 3, %player);
   }
}

function SiegeGame::SiegeAlertPlayer(%game, %count, %player)
{
   if(%count > 1)
      %player.alertThread = %game.schedule(1000, "SiegeAlertPlayer", %count - 1, %player);
   else
      %player.alertThread = %game.schedule(1000, "MissionAreaDamage", %player);
}

function SiegeGame::MissionAreaDamage(%game, %player)
{
   %player.setDamageFlash(0.8);
   %player.setDamageLevel(5);
   %game.onClientKilled(%player.client, 0, $DamageType::OutOfBounds);
}

function SiegeGame::gameOver(%game)
{
   parent::gameOver(%game);
   deactivatePackage(Fortuitous);
}
};
activatepackage(Fortuitous);
